<?php
// Credit Louviaux Jean-Marc 2014
define('checkaccess', TRUE);
include('../config/config_main.php');
include('../config/config_layout.php');

date_default_timezone_set('GMT');

if (isset($_COOKIE['user_lang'])) {
    $user_lang = $_COOKIE['user_lang'];
} else {
    $user_lang = 'English';
}
include('../languages/' . $user_lang . '.php');

for ($i = 1; $i <= $NUMMETER; $i++) {
    include("../config/config_met$i.php");
}
$dir    = '../data/csv';
$output = glob($dir . '/*.csv');
sort($output);
$cnt = count($output);

$file       = file($output[$cnt - 1]);
$contalines = count($file);

if ($contalines < 289 && $cnt > 1) { // Load yesterday values
    $file2       = file($output[$cnt - 2]);
    $contalines2 = count($file2);
    
    $startline = $contalines2 - 290 + $contalines; // (24*12)+2 hearder
    if ($startline < 1) {
        $startline = 2;
    }
    $linearray = preg_split("/,/", $file2[$startline]);
    
    for ($i = 1; $i <= $NUMMETER; $i++) {
        if (isset($linearray[$i])) {
            $val_first24[$i] = trim($linearray[$i]);
        } else {
            $val_first24[$i] = 0;
        }
    }
} else {
    $linearray = preg_split("/,/", $file[1]);
    for ($i = 1; $i <= $NUMMETER; $i++) {
        if (isset($linearray[$i])) {
            $val_first24[$i] = trim($linearray[$i]);
        } else {
            $val_first24[$i] = 0;
        }
    }
}

$todaylinearray = preg_split("/,/", $file[$contalines - 1]);

$year   = substr($output[$cnt - 1], -12, 4);
$month  = substr($output[$cnt - 1], -8, 2);
$day    = substr($output[$cnt - 1], -6, 2);
$hour   = substr($todaylinearray[0], 0, 2);
$minute = substr($todaylinearray[0], 3, 2);

$data[0] = strtotime($year . '-' . $month . '-' . $day . ' ' . $hour . ':' . $minute);
$data[0] *= 1000;

$fileUTCdate = strtotime(date("$year$month$day"));
$todayUTC    = strtotime(date('Ymd'));

$prevlinearray = preg_split("/,/", $file[$contalines - 2]);

if ($fileUTCdate == $todayUTC) {
    $title = '';
} elseif ($fileUTCdate == strtotime(date('Ymd', strtotime('-1 day')))) {
    $title = stripslashes("$lgYESTERDAYTITLE");
} else {
    $dday  = date($DATEFORMAT, $fileUTCdate);
    $title = stripslashes("$dday");
}

$graphlist = array();

for ($i = 1; $i <= $NUMMETER; $i++) {
    $val_first = $val_first24[$i];
    $val_last = trim($todaylinearray[$i]);
    
    settype($val_first, 'float');
    settype($val_last, 'float');
    if (${'TYPE' . $i} != 'Sensor') { // Meter
        if ($val_first <= $val_last) {
            $val_last -= $val_first;
        } else { // counter pass over
            $val_last += ${'PASSO' . $i} - $val_first;
        }
    }
    if (${'PRICE' . $i} > 0) {
        $money[$i] = number_format(($val_last * ${'PRICE' . $i}), 2, $DPOINT, $THSEP);
        $money[$i] = '/' . $money[$i] . $CURS;
    } else {
        $money[$i] = '';
    }
    if (${'TYPE' . $i} == 'Elect') {
        if ($val_last <= 1000) {
            $prefix[$i] = '';
            $val_last   = number_format($val_last, 0, $DPOINT, $THSEP);
        } elseif ($val_last > 1000000) {
            $val_last /= 1000000;
            $prefix[$i] = 'M';
            $val_last   = number_format($val_last, 2, $DPOINT, $THSEP);
        } elseif ($val_last > 1000) {
            $val_last /= 1000;
            $prefix[$i] = 'k';
            $val_last   = number_format($val_last, 2, $DPOINT, $THSEP);
        }
    } else {
        $val_last   = number_format($val_last, ${'PRECI' . $i}, $DPOINT, $THSEP);
        $prefix[$i] = '';
    }
    
    $graphnum = ${'GRAPH_MET' . $i};
    if (!in_array($graphnum, $graphlist)) {
        $graphlist[]          = (int) $graphnum;
        $titlelist[$graphnum] = $title . ' ' . ${'METNAME' . $i} . " ($val_last$prefix[$i]${'UNIT'.$i}$money[$i]) ";
    } else {
        $titlelist[$graphnum] .= '- ' . ${'METNAME' . $i} . " ($val_last$prefix[$i]${'UNIT'.$i}$money[$i]) ";
    }
    
    $val_first = trim($prevlinearray[$i]);
    $val_last  = trim($todaylinearray[$i]);
    
    if (!empty($val_first) && !empty($val_last)) {
        settype($val_first, 'float');
        settype($val_last, 'float');
        if (${'TYPE' . $i} != 'Sensor') { // Meter    
            if ($val_first <= $val_last) {
                $val_last -= $val_first;
            } else { // counter just pass over
                $val_last += ${'PASSO' . $i} - $val_first;
            }
        }
    } else {
        $val_last = 0;
    }
    
    $val_last = round($val_last, ${'PRECI' . $i});
    $data[$i] = $val_last;
}

sort($graphlist);

$cnt = count($graphlist);
for ($j = 0; $j < $cnt; $j++) {
    $data[$i + $j] = $titlelist[$graphlist[$j]];
}

header("Content-type: text/json");
echo json_encode($data);
?>
