<?php
// Credit Louviaux Jean-Marc 2014
define('checkaccess', TRUE);
include('../config/config_main.php');
include('../scripts/memory.php');

@$shmid = shmop_open($MEMORY, 'a', 0, 0);
if (!empty($shmid)) {
    $size = shmop_size($shmid);
    shmop_close($shmid);
    $shmid = shmop_open($MEMORY, 'c', 0644, $size);
    $data  = shmop_read($shmid, 0, $size);
    $data  = json_decode($data, true);
    shmop_close($shmid);
} else { // shared $MEMORY doesn't exist
    for ($i = 1; $i <= $NUMMETER; $i++) {
        $data["Totalcounter$i"] = 0;
    }
}

for ($i = 1; $i <= $NUMMETER; $i++) {
    include("../config/config_met$i.php");
    if (${'TYPE' . $i} != 'Sensor') {
        $val_last = (float) $data["Totalcounter$i"];
        
        if (${'TYPE' . $i} == 'Elect') {
            if ($val_last <= 1000) {
                $prefix   = '';
                $val_last = number_format($val_last, 0, $DPOINT, $THSEP);
            } elseif ($val_last > 1000) {
                $val_last /= 1000;
                $prefix   = 'k';
                $val_last = number_format($val_last, 3, $DPOINT, $THSEP);
            }
        } else {
            settype(${'PRECI' . $i}, 'integer');
            $val_last = number_format($val_last, ${'PRECI' . $i}, $DPOINT, $THSEP);
            $prefix   = '';
        }
    } else {
        $val_last = '--';
        $prefix   = '';
    }
    $data["Totalcounter$i"] = "$val_last$prefix";
}

header("Content-type: text/json");
echo json_encode($data);
?>
